% CoMa2 - SS11
% Aufg.4.3 2.

% Test von intriemann und inttrapez

clear all

% exakter Wert des Integrals
exakt = 5;

% fr diese n testen wir die Quadraturformeln
n = [10 100 1000 10000 100000];
% alternativ: n = 1:100;

a = length(n);

% hier werden die Werte von S^0(n) und S^1(n) stehen
S0 = zeros(1,a); S1 = zeros(1,a);
% und hier jeweils der Aufwand
aufw0 = zeros(1,a); aufw1 = zeros(1,a);

for i=1:a
    [S0(i),aufw0(i)] = intriemann(n(i));
    [S1(i),aufw1(i)] = inttrapez(n(i));
end

% Diskretisierungsfehler
fehler0 = abs(exakt-S0); fehler1 = abs(exakt-S1);
% Effizienz
effi0 = 1 ./ (fehler0 .* aufw0); effi1 = 1 ./ (fehler1 .* aufw1);

% grafische Veranschaulichung
figure(1);
loglog(n,fehler0,'b');
% oder: plot(...)
hold on
loglog(n,fehler1,'r');
% oder: plot(...)
xlabel('Anzahl Sttzstellen');
ylabel('Diskretisierungsfehler');
legend('Riemann','Trapez');
hold off

figure(2);
loglog(n,effi0,'b');
% oder: plot(...)
hold on
loglog(n,effi1,'r');
% oder: plot(...)
xlabel('Anzahl Sttzstellen');
ylabel('Effizienz');
legend('Riemann','Trapez');
hold off